/*
  ----------------------------------------------------------------------
  NOME: 
  CONGNOME: 
  MATRICOLA: 
  CODICE CALCOLATORE: 
  ----------------------------------------------------------------------
*/

#include <iostream>
#include <fstream>
#include <cstdlib>
#include <cstring>

using namespace std;

/* --------------------------- INIZIO PUNTO 1  ------------------------- */
/*                    Scrivere qui sotto la soluzione                    */
/*    vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv   */

//
// Inserire qui le definizioni dei tipi Info, InfoList e ST
//

/*    ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^   */
/* ---------------------------- FINE PUNTO 1  -------------------------- */

/* Non modificare le funzioni sotto */

// 
// Utilizzare la funzione sotto per comparara due stringhe, o array di
// caratteri.
// 
bool Compara_stringhe(const char* s1, const char* s2)
{
  return strcmp(s1, s2) == 0;
}

//
// Utilizzare la funzione per ottenere l'indice dell'elemento
// dell'array che contiene o conterra' l'elemento.
// 
int ST_Hash(ST * s, char * k) {
  int val = 0;
  char c;

  if (s != NULL) {
    while(( c = *k++) != '\0') {
      val = val*997 + c;
    }
    return (((val < 0) ? (val * -1) : val)% s->size);
  }
  else {
    return -1;
  }
}

// Dichiarazione della funzione ST_Print: Non cancellarla.
void ST_Print(ST * st);
/* --------------------------- INIZIO PUNTO 2  ------------------------- */
/*                    Scrivere qui sotto la soluzione                    */
/*    vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv   */
void ST_Print(ST * st) {
//
// Inserire il body della definizione della funzione ST_Print qui
//
}

/*    ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^   */
/* ---------------------------- FINE PUNTO 2 -------------------------- */


// Dichiarazione della funzione ST_Search: Non cancellarla.
Info * ST_Search(ST * s, char k[100]);
/* --------------------------- INIZIO PUNTO 3  ------------------------- */
/*                    Scrivere qui sotto la soluzione                    */
/*    vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv   */

Info * ST_Search(ST * s, char k[100]) {
//
// Inserire il body della definizione della funzione ST_Search qui
//
}

/*    ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^   */
/* ---------------------------- FINE PUNTO 3 -------------------------- */



// Dichiarazione della funzione ST_Insert: Non cancellarla.
bool ST_Insert(ST * s, Info i);
/* --------------------------- INIZIO PUNTO 4  ------------------------- */
/*                    Scrivere qui sotto la soluzione                    */
/*    vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv   */

bool ST_Insert(ST * s, Info i) {
//
// Inserire il body della definizione della funzione ST_Insert qui
//
}

/*    ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^   */
/* ---------------------------- FINE PUNTO 4 -------------------------- */

// Dichiarazione della funzione ST_Delete: Non cancellarla.
bool ST_Delete(ST * s, char name[100]);
/* --------------------------- INIZIO PUNTO 5  ------------------------- */
/*                    Scrivere qui sotto la soluzione                    */
/*    vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv   */

bool ST_Delete(ST * s, char name[100]) {
//
// Inserire il body della definizione della funzione ST_Insert qui
//
}

/*    ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^   */
/* ---------------------------- FINE PUNTO 5 -------------------------- */

/* NON MODIFICARE PER NESSUN MOTIVO IL CODICE SOTTO RIPORTATO */

/* Non modificare le funzione sotto */
void ST_Read(ST * st, const char * fname) {
  ifstream in;

  in.open(fname);

  while(! in.eof()) {
    Info i;
    char name[100];
    char type[50];
    char buf[10];
    int line;

    in.getline(name, 100);
    if(in.fail()) break;

    in.getline(type, 100);
    if(in.fail()) break;

    in.getline(buf, 10);
    if(in.fail()) break;

    line = atoi(buf);

    strcpy(i.name, name);
    strcpy(i.type, type);
    i.line = line;

    ST_Insert(st, i);
  }

  in.close();
}

void dealloca_lista(InfoList * & p) {
  InfoList * l;

  while(p != NULL) {
    l = p;
    p = p->next;
    delete l;
  }
}

void ST_Destroy(ST * s) {
  int i;

  if(s != NULL) {
    for(i = 0; i<s->size; i++) {
      dealloca_lista(s->array[i]);
    }
  }
}

// ----------------------------------------------------------------------
// Main del programma
// ----------------------------------------------------------------------

int main() 
{
  Info * i;

  // Inizializzazione di una tabella dei simboli vuota.
  ST * s = new ST();

  // Inserimento nell tabella dei simboli delle informazioni
  // memorizzate nel file st.dat
  ST_Read(s, "st.dat");

  cout << "========================================" << endl;
  cout << "Initial symbol tabble" << endl;
  ST_Print(s);
  cout << "========================================" << endl;

  i = ST_Search(s, "j");
  if (i != NULL) {
    cout << "Trovato il simbolo " << i->name << endl;
    cout << "Il suo tipo e': " << i->type << endl;
  }
  else {
    cout << "ERRORE: Non trovato il simbolo " << i->name << endl;
    return 1;
  }

  cout << "========================================" << endl;
  cout << "Removing: j" << endl;
  ST_Delete(s, "j");

  i = ST_Search(s, "j");
  if (i != NULL) {
    cout << "ERRORE: trovato il simbolo " << i->name << endl;
    return 1;
  }

  cout << "========================================" << endl;
  ST_Print(s);
  cout << "========================================" << endl;

  i = ST_Search(s, "stprime");
  if (i != NULL) {
    cout << "Trovato il simbolo " << i->name << endl;
    cout << "Il suo tipo e': " << i->type << endl;
  }
  else {
    cout << "ERRORE: Non trovato il simbolo " << i->name << endl;
    return 1;
  }

  cout << "========================================" << endl;
  cout << "Removing: stprime" << endl;
  ST_Delete(s, "stprime");

  i = ST_Search(s, "stprime");
  if (i != NULL) {
    cout << "ERRORE: trovato il simbolo " << i->name << endl;
    return 1;
  }

  cout << "========================================" << endl;
  ST_Print(s);
  cout << "========================================" << endl;

  // Deallocazione delle liste memorizzate in ogni elemento dell'array
  // della tabella dei simboli.
  ST_Destroy(s);

  // Distruzione della struttura tabella dei simboli
  delete s;

  return 0;
}
